import { getChromeStorage } from '@/uilts/chromeExtension.js'
import { srcPublishSuccess } from '@/http/publishApi'
import { bindRepost, bindPostContent } from '@/http/treasure'

// 重新绑定推文id
export const reSetBindTwtterId = ({
    postId = '',
    tweetId = ''
}, callback) => {
    getChromeStorage('userInfo', (_userInfo) => {
        if (_userInfo && _userInfo.uid) {
            srcPublishSuccess({
                params: {
                    postId,
                    srcContentId: tweetId
                }
            }).then((res) => {
                if (res.code == 0 || res.code == 3003) {
                    callback && callback()
                }
            })
        }
    })
}


// 重新绑定推文id
export const reSetBindRepost = (params, callback) => {
    getChromeStorage('userInfo', (_userInfo) => {
        if (_userInfo && _userInfo.uid) {
            bindRepost({
                params
            }).then((res) => {
                if (res.code == 0 || res.code == 3003) {
                    callback && callback()
                }
            })
        }
    })
}



export const reSetBindPostContent = (params, callback) => {
    getChromeStorage('userInfo', (_userInfo) => {
        if (_userInfo && _userInfo.uid) {
            bindPostContent({
                params
            }).then((res) => {
                if (res.code == 0 || res.code == 3003) {
                    callback && callback()
                }
            })
        }
    })
}