import { fetchAddFinishEvent } from '@/logic/background/fetch/facebook'
import Report from "@/log-center/log"

/**
 * facebook分享成功逻辑
 */
export function facebookShareSuccess(params, sender) {
    try {
        let { data } = params;
        let { id } = sender.tab || {};
        chrome.tabs.remove(id);

        if(!data.bizType) {
          fetchAddFinishEvent({
            eventType: data.type,
            luckdropId: data.taskLuckdropId
          }).then(res => {
              if (res.code == 0) {
                  setTimeout(() => {
                      sendActivetabMessage({
                          actionType: 'BG_FACEBOOK_SHARE_SUCCESS',
                          data: data
                      });
                  })
              }
          }).catch((error) => {
              console.log('catch', error)
          })
        }
    } catch (error) {
        Report.reportLog({
            objectType: Report.objectType.background_function_catch,
            funcName: 'facebookShareSuccess',
            errMsg: error.message
        })
    }
}


function sendActivetabMessage(message = {}) {
    try {
        chrome.tabs.query({
            active: true,
            currentWindow: true
        }, (tabs) => {
            chrome.tabs.sendMessage(tabs[0].id, message, res => {
                console.log(res)
            })
        })
    } catch (error) {
        Report.reportLog({
            objectType: Report.objectType.background_function_catch,
            funcName: 'sendActivetabMessage',
            errMsg: error.message
        })
    }
}
